;
; Velleman K8048 PIC16F627 PWM Demo
;
; Copyright (c) 2005-2007 Darron Broad
; All rights reserved.
;
; Licensed under the terms of the BSD license, see file LICENSE
; for details.
;
; $Id: pwm.asm,v 1.3 2007/05/15 20:08:23 darron Exp $
;
                LIST    P=PIC16F627
#INCLUDE        "p16f627.inc"
;*****************************************************************************
;
; PWM Demo (approx 250 Hz)
;
;*****************************************************************************
;
; Configuration word
;
    __CONFIG    _BODEN_ON & _CP_OFF & _DATA_CP_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLRE_ON & _INTRC_OSC_CLKOUT

;
; Code Start
;
                ORG     0x0000
                GOTO    MAIN
                ORG     0x0004
                GOTO    INTSR

;
; Initialise PICMicro
;
INIT            BCF     STATUS,RP0          ;SELECT BANK 0

                MOVLW   B'00000111'         ;DISABLE COMPARATORS
                MOVWF   CMCON

                BSF     STATUS,RP0          ;SELECT BANK 1
                
                CLRF    INTCON              ;DISABLE INTERRUPTS

                BSF     PCON,3              ;INIT INTRC OSC (0=37KHz, 1=4MHz)

                MOVLW   B'10000000'         ;SET OPTIONS (DISABLE PULLUPS)
                MOVWF   OPTION_REG

                MOVLW   B'00000000'         ;PORT B
                MOVWF   TRISB

; PWM
                MOVLW   0xFF                ;FREQUENCY (higher value = lower frequency)
                MOVWF   PR2

                BCF     STATUS,RP0          ;SELECT BANK 0

                MOVLW   0x80                ;MARK/SPACE DUTY CYCLE RATIO (1/2 * PR2=50:50)
                MOVWF   CCPR1L

                MOVLW   0x0c                ;PWM MODE ENABLED
                MOVWF   CCP1CON

                MOVLW   0x06                ;TMR/PWM ON + SYSCLK/16
                MOVWF   T2CON
;

                CLRF    PORTB               ;INIT PORT B
                RETURN

;
; Main program
;
MAIN            CALL    INIT                ;INITIALISE
MAIN0           GOTO    MAIN0               ;LOOP FOREVER

;
; Interrupt service routine (unused)
;
INTSR           RETFIE

;
; Code End
;
                END
