;
; Velleman K8048 PIC16F627 Timer Demo
;
; Copyright (c) 2005-2007 Darron Broad
; All rights reserved.
;
; Licensed under the terms of the BSD license, see file LICENSE
; for details.
;
; $Id: timer.asm,v 1.3 2007/05/15 20:08:23 darron Exp $
;
                LIST    P=PIC16F627
#INCLUDE        "p16f627.inc"
;*****************************************************************************
;
; Timer Demo
;
;*****************************************************************************
;
; Configuration word
;
    __CONFIG    _BODEN_ON & _CP_OFF & _DATA_CP_OFF & _PWRTE_ON & _WDT_OFF & _LVP_OFF & _MCLRE_ON & _INTRC_OSC_CLKOUT

;
; Variables (RAM)
;
W_SAVE          EQU     0x70
S_SAVE          EQU     0x71

;
; Code Start
;
                ORG     0x0000
                GOTO    MAIN
                ORG     0x0004
                GOTO    INTSR

;
; Initialise PICMicro
;
INIT            BCF     STATUS,RP0          ;SELECT BANK 0

                MOVLW   B'00000111'         ;DISABLE COMPARATORS
                MOVWF   CMCON

                BSF     STATUS,RP0          ;SELECT BANK 1
                
                CLRF    INTCON              ;DISABLE INTERRUPTS

                BSF     PCON,3              ;INIT INTRC OSC (0=37KHz, 1=4MHz)

                MOVLW   B'10000000'         ;SET OPTIONS (DISABLE PULLUPS)
                MOVWF   OPTION_REG

                MOVLW   B'00000000'         ;PORT B
                MOVWF   TRISB

                BCF     STATUS,RP0          ;SELECT BANK 0

                CLRF    PORTB               ;INIT PORT B
;
; start timer0
;
                MOVLW   0x80
                MOVWF   TMR0

                MOVLW   0xa0
                MOVWF   INTCON              ;INT TMR0 ON

                RETURN

;
; Main program
;
MAIN            CALL    INIT                ;INITIALISE
MAIN0           GOTO    MAIN0               ;LOOP FOREVER

;
; Interrupt service routine
;
INTSR           MOVWF   W_SAVE
                MOVF    STATUS,W
                MOVWF   S_SAVE

                BCF     STATUS,RP0
                BCF     STATUS,RP1

                INCF    PORTB

                MOVLW   0x80
                MOVWF   TMR0

                MOVF    S_SAVE,W
                MOVWF   STATUS
                MOVF    W_SAVE,W

                BCF     INTCON,2
                RETFIE

;
; Code End
;
                END
