;
; Velleman K8048 Test
;
; Copyright (c) 2005-2007 Darron Broad
; All rights reserved.
;
; Licensed under the terms of the BSD license, see file LICENSE
; for details.
;
; $Id: 3_pic16f88.asm,v 1.6 2007/05/16 03:46:35 darron Exp $
;
                LIST    P=PIC16F88
#INCLUDE        "p16f88.inc"
;*****************************************************************************
;
;   k8048 PIC16F88 Test
;
;*****************************************************************************
;
; Configuration word
;
              __CONFIG  _CONFIG1, _CP_OFF & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _XT_OSC
;             __CONFIG  _CONFIG1, _CP_ALL & _CCP1_RB0 & _DEBUG_OFF & _WRT_PROTECT_ALL & _CPD_ON  & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _XT_OSC
              __CONFIG  _CONFIG2, _IESO_OFF & _FCMEN_OFF
;
; Numerical Constants (DEFINES)
;
DELAYTIMH       EQU     0x80
;
; Data Constants (USERID)
;
                ORG     0x2000
                DE      "PIC!"
;
; Data Constants (EEPROM)
;
                ORG     0x2100
                DE      "PIC!"
;
; Variables
;
DELAYTIMER1     EQU     0x20
DELAYTIMER2     EQU     0x21
;
; Macros
;
; decrement REG, goto LOC if not ZERO
DJNZ            MACRO   REG,LOC
                DECFSZ  REG,F
                GOTO    LOC
                ENDM
;
; Code Start
;
                ORG     0x0000
                GOTO    MAIN
                ORG     0x0004
                GOTO    INTSR
;
; Simple delay
;
DELAY           MOVLW   DELAYTIMH
DELAYLOOP       MOVWF   DELAYTIMER1
DELAYLOOP1      CLRF    DELAYTIMER2
DELAYLOOP2      DJNZ    DELAYTIMER2,DELAYLOOP2
                DJNZ    DELAYTIMER1,DELAYLOOP1
                RETURN
;
; Initialise PICMicro
;
INIT            BSF     STATUS,RP0          ;SELECT BANK 1

                MOVLW   B'10000000'         ;SET OPTIONS (DISABLE PULLUPS)
                MOVWF   OPTION_REG

                MOVLW   B'11111111'         ;PORT A ALL I/P
                MOVWF   TRISA
                
                MOVLW   B'11000000'         ;PORT B LD1..LD6 O/P
                MOVWF   TRISB

                CLRF    INTCON              ;DISABLE INTERRUPTS

                BCF     STATUS,RP0          ;SELECT BANK 0

                MOVLW   B'00000111'         ;DISABLE COMPARATORS
                MOVWF   CMCON

                RETURN
;
; Main program
;
MAIN            CALL    INIT                ;INITIALISE

MAIN1           CLRF    PORTB               ;CLEAR PORT

MAIN2           CALL    DELAY               ;DELAY SOME TIME
                INCF    PORTB               ;INCREMENT PORT
                GOTO    MAIN2
;
; Interrupt service routine (unused)
;
INTSR           RETFIE
;
; Code End
;
                END
