;
; Velleman K8048 Test
;
; Copyright (c) 2005-2007 Darron Broad
; All rights reserved.
;
; Licensed under the terms of the BSD license, see file LICENSE
; for details.
;
; $Id: 5_pic16f819.asm,v 1.5 2007/05/15 20:08:23 darron Exp $
;
                LIST    P=PIC16F819
#INCLUDE        "p16f819.inc"
;*****************************************************************************
;
;   k8048 PIC16F819 Test
;
;*****************************************************************************
;
; Configuration word
;
;             __CONFIG  _CP_OFF & _CCP1_RB2 & _DEBUG_OFF & _WRT_ENABLE_OFF  & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _XT_OSC
              __CONFIG  _CP_ALL & _CCP1_RB2 & _DEBUG_OFF & _WRT_ENABLE_1536 & _CPD_ON  & _LVP_OFF & _BODEN_OFF & _MCLR_ON & _PWRTE_ON & _WDT_OFF & _XT_OSC
;
; Numerical Constants (DEFINES)
;
DELAYTIMH       EQU     0x80
;
; Data Constants (USERID)
;
                ORG     0x2000
                DE      "PIC!"
;
; Data Constants (EEPROM)
;
                ORG     0x2100
                DE      "EEPROM WRITE TEST"
;
; Variables
;
DELAYTIMER1     EQU     0x20
DELAYTIMER2     EQU     0x21
;
; Macros
;
; decrement REG, goto LOC if not ZERO
DJNZ            MACRO   REG,LOC
                DECFSZ  REG,F
                GOTO    LOC
                ENDM
;
; Code Start
;
                ORG     0x0000
                GOTO    MAIN
                ORG     0x0004
                GOTO    INTSR
;
; Simple delay
;
DELAY           MOVLW   DELAYTIMH
DELAYLOOP       MOVWF   DELAYTIMER1
DELAYLOOP1      CLRF    DELAYTIMER2
DELAYLOOP2      DJNZ    DELAYTIMER2,DELAYLOOP2
                DJNZ    DELAYTIMER1,DELAYLOOP1
                RETURN
;
; Initialise PICMicro
;
INIT            BSF     STATUS,RP0          ;SELECT BANK 1

                MOVLW   B'10000000'         ;SET OPTIONS (DISABLE PULLUPS)
                MOVWF   OPTION_REG

                MOVLW   B'11111111'         ;PORT A ALL I/P
                MOVWF   TRISA
                
                MOVLW   B'11000000'         ;PORT B LD1..LD6 O/P
                MOVWF   TRISB

                CLRF    INTCON              ;DISABLE INTERRUPTS

                BCF     STATUS,RP0          ;SELECT BANK 0

                RETURN
;
; Main program
;
MAIN            CALL    INIT                ;INITIALISE

MAIN1           CLRF    PORTB               ;CLEAR PORT

MAIN2           CALL    DELAY               ;DELAY SOME TIME
                INCF    PORTB               ;INCREMENT PORT
                GOTO    MAIN2
;
; Interrupt service routine (unused)
;
INTSR           RETFIE
;
; Code End
;
                END
