;
; Velleman K8048 Test
;
; Copyright (c) 2005-2007 Darron Broad
; All rights reserved.
;
; Licensed under the terms of the BSD license, see file LICENSE
; for details.
;
; $Id: 7_pic12f675.asm,v 1.9 2007/05/15 20:08:23 darron Exp $
;
; Socket pins for GPIO probes:
;
;           8PIN    14PIN   18PIN   28PIN
;           ----    ------  -----   -----
;   GP0     7       13      13      28      PGD
;   GP1     6       12      12      27      PGC
;   GP2     5       10      6       2       LD1
;   GP3     4       4                       MCLR
;   GP4     3       9       7       3       LD2
;   GP5     2               17      21      SW1
;
; TRISIO= XX10X0XX
;
                LIST    P=PIC12F675
#INCLUDE        "p12f675.inc"
;*****************************************************************************
;
;   k8048 PIC12F675 Test
;
;*****************************************************************************
;
; Configuration word
;
              __CONFIG  _CPD_OFF & _CP_OFF & _BODEN_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_CLKOUT
;             __CONFIG  _CPD_ON  & _CP_ON  & _BODEN_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_CLKOUT
;
; Numerical Constants (DEFINES)
;
DELAYTIMH       EQU     0xc0
;
; Data Constants (USERID)
;
                ORG     0x2000
                DE      "PIC!"
;
; Data Constants (EEPROM)
;
                ORG     0x2100
                DE      "EEPROM WRITE TEST",0
;
; Variables
;
DELAYTIMER1     EQU     0x20
DELAYTIMER2     EQU     0x21
;
; Macros
;
; decrement REG, goto LOC if not ZERO
DJNZ            MACRO   REG,LOC
                DECFSZ  REG,F
                GOTO    LOC
                ENDM
;
; Code Start
;
                ORG     0x0000
                GOTO    MAIN
                ORG     0x0004
                GOTO    INTSR
;
; Simple delay
;
DELAY           MOVLW   DELAYTIMH
DELAYLOOP       MOVWF   DELAYTIMER1
DELAYLOOP1      CLRF    DELAYTIMER2
DELAYLOOP2      DJNZ    DELAYTIMER2,DELAYLOOP2
                DJNZ    DELAYTIMER1,DELAYLOOP1
                RETURN
;
; Initialise PICMicro
;
INIT            BCF     STATUS,RP0          ;SELECT BANK 0
                
                CLRF    INTCON              ;DISABLE INTERRUPTS
                MOVLW   B'00000111'         ;DISABLE COMPARATORS
                MOVWF   CMCON
                
                CLRF    GPIO

                BSF     STATUS,RP0          ;SELECT BANK 1
                CALL    0x03ff              ;RETRIEVE OSCILLATOR CALIBRATION VALUE
                MOVWF   OSCCAL              ;STORE

                CLRF    ANSEL
                CLRF    WPU
                
                MOVLW   B'11111011'         ;GPIO LD1 O/P (X,X,SW1,LD2,X,LD1,X,X)
                MOVWF   TRISIO

                MOVLW   B'10000000'
                MOVWF   OPTION_REG

                BCF     STATUS,RP0          ;SELECT BANK 0

                RETURN
;
; Main program
;
MAIN            CALL    INIT                ;INITIALISE

MAIN1           MOVLW   B'00000100'
                MOVWF   GPIO
                CALL    DELAY

                MOVLW   B'00000000'
                MOVWF   GPIO
                CALL    DELAY

                GOTO    MAIN1               ;START AGAIN
;
; Interrupt service routine (unused)
;
INTSR           RETFIE
;
; Code End
;
                END
