;
; Velleman K8048 Test
;
; Copyright (c) 2005-2007 Darron Broad
; All rights reserved.
;
; Licensed under the terms of the BSD license, see file LICENSE
; for details.
;
; $Id: b_pic18f252.asm,v 1.3 2007/05/15 20:08:23 darron Exp $
;
                LIST    P=PIC18F252
#INCLUDE        "p18f252.inc"
;*****************************************************************************
;
;   k8048 PIC18F252 Test
;
;*****************************************************************************
;
; Configuration words
;
              __CONFIG _CONFIG1H, _OSCS_OFF_1H  & _XT_OSC_1H

              __CONFIG _CONFIG2L, _BORV_20_2L   & _BOR_OFF_2L    & _PWRT_ON_2L
              __CONFIG _CONFIG2H, _WDTPS_128_2H & _WDT_OFF_2H

              __CONFIG _CONFIG3H, _CCP2MX_OFF_3H 

              __CONFIG _CONFIG4L, _DEBUG_OFF_4L & _LVP_OFF_4L    & _STVR_ON_4L

              __CONFIG _CONFIG5L, _CP3_OFF_5L   & _CP2_OFF_5L    & _CP1_OFF_5L   & _CP0_OFF_5L

              __CONFIG _CONFIG5H, _CPD_OFF_5H   & _CPB_OFF_5H
              
              __CONFIG _CONFIG6L, _WRT3_OFF_6L  & _WRT2_OFF_6L   & _WRT1_OFF_6L  & _WRT0_OFF_6L

              __CONFIG _CONFIG6H, _WRTD_OFF_6H  & _WRTB_OFF_6H   & _WRTC_OFF_6H
              
              __CONFIG _CONFIG7L, _EBTR3_OFF_7L & _EBTR2_OFF_7L  & _EBTR1_OFF_7L & _EBTR0_OFF_7L
              __CONFIG _CONFIG7H, _EBTRB_OFF_7H
;
; Numerical Constants (DEFINES)
;
DELAYTIML       EQU     0x00
DELAYTIMM       EQU     0x00
DELAYTIMH       EQU     0x02
;
; Data Constants (USERID)
;
                ORG     0x200000
                DB      0,1,2,3,4,5,6,7
;
; Data Constants (EEPROM)
;
                ORG     0xF00000
                DE      "Test"
;
; Variables
;
COUNTER0        EQU     0x20
;
COUNTER1        EQU     0x30    ;GENERAL PURPOSE COUNTERS
COUNTER2        EQU     0x31
COUNTER3        EQU     0x32
;
; Macros
;
; decrement REG, goto LOC if not ZERO
DJNZ            MACRO   REG,LOC
                DECFSZ  REG,F
                GOTO    LOC
                ENDM
;
; Code Start
;
                ORG     0x0000
                GOTO    MAIN
;
; Simple delay
;
DELAY           MOVLW   DELAYTIMH
                MOVWF   COUNTER3
DELAYLOOPH      MOVLW   DELAYTIMM
                MOVWF   COUNTER2
DELAYLOOPM      MOVLW   DELAYTIML
                MOVWF   COUNTER1
DELAYLOOPL      DJNZ    COUNTER1,DELAYLOOPL
                DJNZ    COUNTER2,DELAYLOOPM
                DJNZ    COUNTER3,DELAYLOOPH
                RETURN
;
; Initialise PICMicro
;
INIT            CLRF    ADCON0          ;A/D OFF
                MOVLW   0x0f
                MOVWF   ADCON1

                MOVLW   b'11000000'
                MOVWF   TRISA
                MOVLW   b'11111111'
                MOVWF   TRISB

                CLRF    PORTA
                CLRF    PORTB
                CLRF    COUNTER0

                RETURN
;
; Main program
;
MAIN            CALL    INIT

MAIN1           INCF    COUNTER0

                MOVF    COUNTER0,W
                ANDLW   0x3f
                MOVWF   PORTA

                CALL    DELAY

                GOTO    MAIN1
;
; Interrupt service routine (unused)
;
INTSR           RETFIE
;
; Code End
;
                END
