/*
 * Velleman K8048 Programmer for FreeBSD and others.
 *
 * Copyright (c) 2005-2007 Darron Broad
 * All rights reserved.
 *
 * Licensed under the terms of the BSD license, see file LICENSE
 * for details.
 *
 * $Id: pic.h,v 1.7 2007/05/15 01:06:21 darron Exp $
 */

#ifndef _PIC_H
#define _PIC_H

#define DATAWIDTH (16)
#define CODEWIDTH (8)

long pic_read_program_memory_block(struct k8048 *, unsigned short *, int);
long pic_read_data_memory_block(struct k8048 *, unsigned char *, int);
int  pic_program_verify(struct k8048 *, const char *, int);
void pic_unprotect(struct k8048 *);
void pic_blank(struct k8048 *);
void pic_dumpdeviceid(struct k8048 *);
void pic_dumpconfig(struct k8048 *);
void pic_writeconfig(struct k8048 *, unsigned short);
void pic_dumposccal(struct k8048 *);
void pic_writeosccal(struct k8048 *, unsigned short);
void pic_dumpflash(struct k8048 *, unsigned short);
void pic_dumpeeprom(struct k8048 *, unsigned short);

#endif /* !_PIC_H */
